# ##############################################################################
# The contents of this file are subject to the PyTis Public License Version    #
# 2.0 (the "License"); you may not use this file except in compliance with     #
# the License. You may obtain a copy of the License at:                        #
#                                                                              #
#     http://www.PyTis.com/License/                                            #
#                                                                              #
#     Copyright (c) 2009 - 2016 Josh Lee                                       #
#                                                                              #
# Software distributed under the License is distributed on an "AS IS" basis,   #
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License     #
# for the specific language governing rights and limitations under the         #
# License.                                                                     #
#                                                                              #
# @auto-generated by the PyTis Copyright Tool on 04:42 04 Apr, 2016            #
############################################################################## #
import getpass, os

#configdir = '/home/leejo7a/etc'
#logdir = '/home/leejo7a/log'

def logdir():
	if bool(getpass.getuser()=='root'):
		logdir=os.path.abspath('/var/log/pytis')
	else:
		try:
			from win32com.shell import shellcon, shell
			logdir = shell.SHGetFolderPath(0, shellcon.CSIDL_APPDATA, 0, 0)
		except ImportError: # quick semi-nasty fallback for non-windows/win32com case
			logdir = os.path.abspath(os.path.join(os.path.expanduser("~"),'log'))
	if not os.path.exists(logdir) or not os.path.isdir(logdir):
		try:
			os.makedirs(logdir, 0o777)
		except (OSError, IOError):
			print("could not create the config dir: %s" % logdir)
			return
	return logdir

def configdir():
	if bool(getpass.getuser()=='root'):
		homedir=os.path.abspath('/etc/pytis')
	else:
		try:
			from win32com.shell import shellcon, shell
			homedir = shell.SHGetFolderPath(0, shellcon.CSIDL_APPDATA, 0, 0)
		except ImportError: # quick semi-nasty fallback for non-windows/win32com case
			homedir = os.path.expanduser("~")
	if not os.path.exists(homedir) or not os.path.isdir(homedir):
		try:
			os.makedirs(homedir, 0o777)
		except (OSError, IOError):
			print("could not create the config dir: %s" % homedir)
			return
	return homedir

configdir=configdir()
logdir=logdir()

__all__ = ['configdir', 'logdir']

